zsh-workers
 help / color / mirror / code / Atom feed
From: Jaime Vargas <jev@mac.com>
To: zsh-workers@sunsite.dk
Subject: Re: zpty woes
Date: Thu, 15 May 2008 12:25:44 -0400	[thread overview]
Message-ID: <22C7A43F-E19E-451D-A980-E79140BF8B3A@mac.com> (raw)
In-Reply-To: <20080515145054.GC5190@sc.homeunix.net>

Still doesn't work for me. Below is the modified script and the debug  
output.

#!/opt/csw/bin/zsh

set -x

zmodload zsh/zpty

die() {print -r -- $1 >&2; exit 1;}

zpty scppty scp hello.world jvargas@aoma6000-4-9.aoma.rhbss.com:~/
zpty -t scppty || die "fuck"
zpty -r scppty line "*:" || die "no password asked"
zpty -w scppty "3lp&tbw"
while zpty -r scppty line;
     do
         result+="$line"$'\n'
     done
zpty -d scppty
print $result

I changed my credentials for security. Basically it now hangs waitng  
for password and doesnt' do anything.  -- Jaime

nerd% ./zpty-test.zsh
+./zpty-test.zsh:5> zmodload zsh/zpty
+./zpty-test.zsh:10> zpty scppty scp hello.world 'luser@host:~/'
+./zpty-test.zsh:11> zpty -t scppty
+./zpty-test.zsh:12> zpty -r scppty line '*:'
+./zpty-test.zsh:13> zpty -w scppty 'TopSecret'
+./zpty-test.zsh:14> zpty -r scppty line
+./zpty-test.zsh:16> result+='1> scp hello.world  
'\''jvargas@aoma6000-4-9.aoma.rhbss.com:~/'\''

'
+./zpty-test.zsh:14> zpty -r scppty line
+./zpty-test.zsh:16> result+='THIS IS A PROPRIETARY RANDOM HOUSE  
SYSTEM, RESTRICTED TO AUTHORIZED

'
+./zpty-test.zsh:14> zpty -r scppty line
+./zpty-test.zsh:16> result+='PERSONNEL AND FOR OFFICIAL, AUTHORIZED  
RANDOM HOUSE BUSINESS ONLY.

'
+./zpty-test.zsh:14> zpty -r scppty line
+./zpty-test.zsh:16> result+='ANYONE USING THIS SYSTEM, NETWORK OR  
DATA IS SUBJECT TO MONITORING

'
+./zpty-test.zsh:14> zpty -r scppty line
+./zpty-test.zsh:16> result+='AT ANY TIME.  ANYONE USING THIS SYSTEM  
THEREBY EXPRESSLY CONSENTS

'
+./zpty-test.zsh:14> zpty -r scppty line
+./zpty-test.zsh:16> result+='TO SUCH MONITORING AND IS FURTHER  
ADVISED THAT ANY EVIDENCE OF

'
+./zpty-test.zsh:14> zpty -r scppty line
+./zpty-test.zsh:16> result+='CRIMINAL AND/OR OTHERWISE IMPROPER OR  
UNAUTHORIZED ACTIVITY MAY

'
+./zpty-test.zsh:14> zpty -r scppty line
+./zpty-test.zsh:16> result+='BE PROVIDED TO LAW ENFORCEMENT  
OFFICIALS FOR PROSECUTION AND/OR

'
+./zpty-test.zsh:14> zpty -r scppty line
+./zpty-test.zsh:16> result+='USED BY RANDOM HOUSE AS IT SEES FIT.

'
+./zpty-test.zsh:14> zpty -r scppty line
+./zpty-test.zsh:16> result+='

'
+./zpty-test.zsh:14> zpty -r scppty line


..... it waits forever here.

On May 15, 2008, at 10:50 AM, Stephane Chazelas wrote:


> On Thu, May 15, 2008 at 02:18:57PM +0100, Peter Stephenson wrote:
>
>> Jaime Vargas wrote:
>>
>>> In the script attached, when trying to follwing line always fails.
>>>
>>>      zpty -r scppty line "*:" || echo "no password asked" && exit
>>>
>>> It appears that the "password" string from the ssh session is  
>>> discarded
>>> by the psuedo terminal.
>>>
>>> Is there a way to fix this? or Am I missing something?
>>>
>>
>> Yes and yes, but it's annoying and I spent a few minutes  
>> rediscovering
>> the arcana.  zpty attempts to read in whole lines, while the password
>> prompt isn't a whole line.  I came across this myself and looked  
>> at the
>> code a while ago and it seemed unnecessarily obscure.  However, I  
>> worked
>> around it and don't have time to make it work sensibly in all the
>> possible cases, so I'm not touching it.  (If anyone's interested  
>> it's in
>> ptyread() in Src/Modules/zpty.c and could definitely do with someone
>> taking it over; it's pretty much self-contained.)
>>
>> To work around this, you need to use non-blocking mode, i.e. start  
>> with
>> "zpty -b scppty ...".  I think (although the code is obscure) that  
>> with
>> your "*:" pattern this will work, i.e. although it doesn't block  
>> it will
>> carry on reading until it gets the password input.  If not, you would
>> need to delay (the zsh/zselect module allows you to do this in  
>> 100ths of
>> a second) and retry.  (Waiting for a pattern with noblocking is
>> effectively a busy wait so even this isn't ideal---you can add the -t
>> option to the -r command line to test first, but then it *won't* wait
>> if there's no input and you do have to delay in your script.)
>>
> [...]
>
> It works for me without "-b", why would you say "-b" is
> necessary?
>
> The problem I've found is that zpty -r doesn't return when the
> command in the pty has terminated. A strace -p shows:
>
> read(12, 0xb7ba04c8, 1)                 = -1 EIO (Input/output error)
> read(12, 0xb7ba04c8, 1)                 = -1 EIO (Input/output error)
> read(12, 0xb7ba04c8, 1)                 = -1 EIO (Input/output error)
> read(12, 0xb7ba04c8, 1)                 = -1 EIO (Input/output error)
> read(12, 0xb7ba04c8, 1)                 = -1 EIO (Input/output error)
> read(12, 0xb7ba04c8, 1)                 = -1 EIO (Input/output error)
> read(12, 0xb7ba04c8, 1)                 = -1 EIO (Input/output error)
> read(12, 0xb7ba04c8, 1)                 = -1 EIO (Input/output error)
> read(12, 0xb7ba04c8, 1)                 = -1 EIO (Input/output error)
> [...]
>
> And the other problem I mentionned in another email about the
> PS4 output not being correct.
>
> -- 
> Stéphane
On May 15, 2008, at 10:50 AM, Stephane Chazelas wrote:

> On Thu, May 15, 2008 at 02:18:57PM +0100, Peter Stephenson wrote:
>> Jaime Vargas wrote:
>>> In the script attached, when trying to follwing line always fails.
>>>
>>>      zpty -r scppty line "*:" || echo "no password asked" && exit
>>>
>>> It appears that the "password" string from the ssh session is  
>>> discarded
>>> by the psuedo terminal.
>>>
>>> Is there a way to fix this? or Am I missing something?
>>
>> Yes and yes, but it's annoying and I spent a few minutes  
>> rediscovering
>> the arcana.  zpty attempts to read in whole lines, while the password
>> prompt isn't a whole line.  I came across this myself and looked  
>> at the
>> code a while ago and it seemed unnecessarily obscure.  However, I  
>> worked
>> around it and don't have time to make it work sensibly in all the
>> possible cases, so I'm not touching it.  (If anyone's interested  
>> it's in
>> ptyread() in Src/Modules/zpty.c and could definitely do with someone
>> taking it over; it's pretty much self-contained.)
>>
>> To work around this, you need to use non-blocking mode, i.e. start  
>> with
>> "zpty -b scppty ...".  I think (although the code is obscure) that  
>> with
>> your "*:" pattern this will work, i.e. although it doesn't block  
>> it will
>> carry on reading until it gets the password input.  If not, you would
>> need to delay (the zsh/zselect module allows you to do this in  
>> 100ths of
>> a second) and retry.  (Waiting for a pattern with noblocking is
>> effectively a busy wait so even this isn't ideal---you can add the -t
>> option to the -r command line to test first, but then it *won't* wait
>> if there's no input and you do have to delay in your script.)
> [...]
>
> It works for me without "-b", why would you say "-b" is
> necessary?
>
> The problem I've found is that zpty -r doesn't return when the
> command in the pty has terminated. A strace -p shows:
>
> read(12, 0xb7ba04c8, 1)                 = -1 EIO (Input/output error)
> read(12, 0xb7ba04c8, 1)                 = -1 EIO (Input/output error)
> read(12, 0xb7ba04c8, 1)                 = -1 EIO (Input/output error)
> read(12, 0xb7ba04c8, 1)                 = -1 EIO (Input/output error)
> read(12, 0xb7ba04c8, 1)                 = -1 EIO (Input/output error)
> read(12, 0xb7ba04c8, 1)                 = -1 EIO (Input/output error)
> read(12, 0xb7ba04c8, 1)                 = -1 EIO (Input/output error)
> read(12, 0xb7ba04c8, 1)                 = -1 EIO (Input/output error)
> read(12, 0xb7ba04c8, 1)                 = -1 EIO (Input/output error)
> [...]
>
> And the other problem I mentionned in another email about the
> PS4 output not being correct.
>
> -- 
> Stéphane


  parent reply	other threads:[~2008-05-15 16:30 UTC|newest]

Thread overview: 15+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2008-05-15 12:02 Jaime Vargas
2008-05-15 13:10 ` Stephane Chazelas
2008-05-15 13:18 ` Peter Stephenson
2008-05-15 14:50   ` Stephane Chazelas
2008-05-15 15:26     ` Peter Stephenson
2008-05-15 16:25     ` Jaime Vargas [this message]
2008-05-15 16:36       ` * " Peter Stephenson
     [not found]     ` <99E8D43E-EC34-48DB-A5AD-BFA197A3AAA3@mac.com>
2008-05-15 17:03       ` Stephane Chazelas
     [not found]       ` <480CEB80051F27AE@mac.com>
2008-05-15 17:38         ` Jaime Vargas
2008-05-15 17:53           ` Jaime Vargas
2008-05-20  3:25             ` Jaime Vargas
2008-05-20 14:28               ` zpty woes (enhancement request) Jaime Vargas
2008-05-20 16:25                 ` Bart Schaefer
2008-05-15 13:26 ` zpty woes Stephane Chazelas
2008-05-15 15:44   ` Peter Stephenson

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=22C7A43F-E19E-451D-A980-E79140BF8B3A@mac.com \
    --to=jev@mac.com \
    --cc=zsh-workers@sunsite.dk \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
Code repositories for project(s) associated with this public inbox

	https://git.vuxu.org/mirror/zsh/

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for NNTP newsgroup(s).